var document, AJS;

if(typeof(ENERJISA_ADMIN) == "undefined") {
    var ENERJISA_ADMIN = {};
}
ENERJISA_ADMIN.showCapability = function() {

    var e = setInterval(function(){
        var $label = AJS.$('#ghx-content-group div[class*="ghx-backlog-header"]');

        if ($label.size() > 0){
            $label.each(function() {
                var sprintId = "";
                try {
                    sprintId = AJS.$(this).parent('div').context.getAttribute("data-sprint-id");
                }catch (e) {
                    console.log("Sprint Id Alınamadı.")
                }

                var currentUrl = window.location.href;
                var url = new URL(currentUrl);
                var rapidView = url.searchParams.get("rapidView");

                var sprintInfo = {
                    "sprintInfo": {
                        "boardId": rapidView,
                        "sprintId": sprintId
                    }
                };

                var capacity = "";
                jQuery.ajax({
                    url: "/rest/sprintrestresource/1.0/getSprintCapability",
                    type: "POST",
                    dataType: 'json',
                    contentType: "application/json",
                    data : JSON.stringify(sprintInfo),
                    success : function(data) {
                        capacity = data.capasity;
                        document.getElementById("capability-value-"+sprintId).innerText = capacity;
                        document.getElementById("inp-new-capability-"+sprintId).value = capacity;
                    },
                    error : function(xhr, ajaxOptions, thrownError) {
                        var errorAddCapabilityFlag = AJS.flag({
                            type: 'error',
                            body: 'Capability value could not set. ERROR('+xhr.status+'): ' + thrownError,
                        });
                        setTimeout(function () {
                            errorAddCapabilityFlag.close();
                        }, 5000);
                    }
                });

                if (sprintId != null || sprintId != ""){
                    AJS.$(this).append("<div id='sprint_"+sprintId+"' style='margin: 0 3%; color: #6b778c; font-size: 12px;'>" +
                                        "<aui-label for=\"my-toggle\">" +
                                            "Capasity: <span id='capability-value-"+sprintId+"'></span>&nbsp;&nbsp;" +
                                            "<a id=\"replace-text-trigger\" " +
                                                "data-replace-text=\"Cancel\" class=\"aui-expander-trigger\" " +
                                                "aria-controls=\"expander-with-replace-text-content-"+sprintId+"\">Edit</a>" +
                                            "<div id=\"expander-with-replace-text-content-"+sprintId+"\" class=\"aui-expander-content\">\n" +
                                                "<form class=\"aui\" action=\"javascript:void(0);\">\n" +
                                                    "<div class=\"field-group\">" +
                                                        "<label for=\"comment-email\">Capability\n" +
                                                            "<span class=\"aui-icon icon-required\">(required)</span></label>\n" +
                                                        "<input class=\"text medium-field\" type=\"text\"\n" +
                                                                "id=\"inp-new-capability-"+sprintId+"\" name=\"inp-new-capability\" " +
                                                                "placeholder=\"Only Number\">\n" +
                                                        "&nbsp;&nbsp;" +
                                                        "<button onclick='ENERJISA_ADMIN.updateCapability("+sprintId+")' " +
                                                                "class=\"aui-button\">Save</button>"+
                                                    "</div>\n" +
                                                "</form>"+
                                            "</div>"+
                                        "</aui-label> " +
                                    "</div>");
                }
            });
            clearInterval(e);
        }

    }, 1000);
};

ENERJISA_ADMIN.updateCapability = function(sprintId) {
    var newCapability = AJS.$("#inp-new-capability-"+sprintId).val();

    var currentUrl = window.location.href;
    var url = new URL(currentUrl);
    var rapidView = url.searchParams.get("rapidView");

    if (newCapability == null || newCapability == ""){
        var emptyCapabilityErrorFlag = AJS.flag({
            type: 'error',
            body: 'Capacity cannot be empty!',
        });
        setTimeout(function () {
            emptyCapabilityErrorFlag.close();
        }, 5000);
    } else {

        newCapability = newCapability.replace(",", ".");

        var sprintInfo = {
            "sprintInfo": {
                "boardId": rapidView,
                "sprintId": sprintId,
                "capability": newCapability
            }
        };

        jQuery.ajax({
            url: "/rest/sprintrestresource/1.0/addNewSprintCapability",
            type: "POST",
            dataType: 'json',
            contentType: "application/json",
            data : JSON.stringify(sprintInfo),
            success : function(data) {
                window.location.reload();

                var successAddCapabilityFlag = AJS.flag({
                    type: 'success',
                    body: 'capability value set to '+newCapability+". Page refreshing...",
                });
                setTimeout(function () {
                    successAddCapabilityFlag.close();
                }, 5000);
            },
            error : function(xhr, ajaxOptions, thrownError) {
                var errorAddCapabilityFlag = AJS.flag({
                    type: 'error',
                    body: 'Capability value could not set. ERROR('+xhr.status+'): ' + thrownError,
                });
                setTimeout(function () {
                    errorAddCapabilityFlag.close();
                }, 5000);
            }
        });
    }
};

AJS.$(document).ready(function() {
    ENERJISA_ADMIN.showCapability();

    var currentUrl = window.location.href;
    var url = new URL(currentUrl);
    var rapidView = url.searchParams.get("rapidView");
    var activeSprintId = 0;

    jQuery.ajax({
        url: "/rest/agile/1.0/board/"+rapidView+"/sprint",
        type: "GET",
        'async': false,
        data : {},
        success : function(data) {
            var allSprints = data.values;
            if (allSprints.length > 0){
                for (var i = 0; i < allSprints.length ; i++){
                    if (allSprints[i].state == "active"){
                        activeSprintId = allSprints[i].id;
                    }
                }
            }
        },
        error : function(response) {
            /*
            var errorBoardFlag = AJS.flag({
                type: 'error',
                body: 'Sprint çekilirken hata alındı! Jira admini ile iletişime geçiniz.',
            });
            setTimeout(function(){ errorBoardFlag.close(); }, 5000);

             */
        }
    });

    if (activeSprintId != null || activeSprintId != "" || activeSprintId != 0){
        var sprintInfo = {
            "sprintInfo": {
                "boardId": rapidView,
                "sprintId": activeSprintId
            }
        };

        var capacity = "";
        jQuery.ajax({
            url: "/rest/sprintrestresource/1.0/getSprintCapability",
            type: "POST",
            dataType: 'json',
            contentType: "application/json",
            data : JSON.stringify(sprintInfo),
            success : function(data) {
                capacity = data.capasity;

                var $label = AJS.$('#ghx-header');
                $label.append("<div><p style='font-size: 14px; color: #6b778c;'>Active Sprint Capasity: "+capacity+"</p></div>")
            },
            error : function(xhr, ajaxOptions, thrownError) {
                var errorAddCapabilityFlag = AJS.flag({
                    type: 'error',
                    body: 'Capability value could not set. ERROR('+xhr.status+'): ' + thrownError,
                });
                setTimeout(function () {
                    errorAddCapabilityFlag.close();
                }, 5000);
            }
        });
    }


});